var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { CreateTableCommand, DescribeTableCommand, DynamoDBClient, GetItemCommand, PutItemCommand, } from '@aws-sdk/client-dynamodb';
import { marshall, unmarshall } from '@aws-sdk/util-dynamodb';
import { DbPlugin, } from '@jovotech/framework';
var DynamoDb = /** @class */ (function (_super) {
    __extends(DynamoDb, _super);
    function DynamoDb(config) {
        var _a;
        var _this = _super.call(this, config) || this;
        _this.client = new DynamoDBClient(((_a = _this.config.libraryConfig) === null || _a === void 0 ? void 0 : _a.dynamoDbClient) || {});
        return _this;
    }
    DynamoDb.prototype.getDefaultConfig = function () {
        return __assign(__assign({}, _super.prototype.getDefaultConfig.call(this)), { table: {
                name: '<YOUR-TABLE-NAME>',
                primaryKeyColumn: 'userId',
                createTableOnInit: true,
                readCapacityUnits: 2,
                writeCapacityUnits: 2,
            }, libraryConfig: {
                marshall: {
                    removeUndefinedValues: true,
                    convertClassInstanceToMap: true,
                },
            } });
    };
    DynamoDb.prototype.getInitConfig = function () {
        return { table: { name: '<YOUR-TABLE-NAME>' } };
    };
    DynamoDb.prototype.mount = function (parent) {
        var _a;
        _super.prototype.mount.call(this, parent);
        // initialize a new client for the mounted instance with the given request-config
        this.client = new DynamoDBClient(((_a = this.config.libraryConfig) === null || _a === void 0 ? void 0 : _a.dynamoDbClient) || {});
    };
    DynamoDb.prototype.initialize = function () {
        return __awaiter(this, void 0, void 0, function () {
            var params, command, e_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 6]);
                        params = {
                            TableName: this.config.table.name,
                        };
                        command = new DescribeTableCommand(params);
                        return [4 /*yield*/, this.client.send(command)];
                    case 1:
                        _a.sent();
                        return [3 /*break*/, 6];
                    case 2:
                        e_1 = _a.sent();
                        if (!(e_1.name === 'ResourceNotFoundException')) return [3 /*break*/, 5];
                        if (!this.config.table.createTableOnInit) return [3 /*break*/, 4];
                        return [4 /*yield*/, this.createTable()];
                    case 3:
                        _a.sent();
                        throw new Error('Creating a table. Please wait a moment and resend the request...');
                    case 4: throw new Error("Table " + this.config.table.name + " does not exist and setting up a table automatically deactivated. Please setup a table manually.");
                    case 5: throw e_1;
                    case 6: return [2 /*return*/];
                }
            });
        });
    };
    DynamoDb.prototype.createTable = function () {
        return __awaiter(this, void 0, void 0, function () {
            var params;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        params = {
                            AttributeDefinitions: [
                                {
                                    AttributeName: this.config.table.primaryKeyColumn,
                                    AttributeType: 'S',
                                },
                            ],
                            KeySchema: [
                                {
                                    AttributeName: this.config.table.primaryKeyColumn,
                                    KeyType: 'HASH',
                                },
                            ],
                            ProvisionedThroughput: {
                                ReadCapacityUnits: this.config.table.readCapacityUnits,
                                WriteCapacityUnits: this.config.table.writeCapacityUnits,
                            },
                            TableName: this.config.table.name,
                        };
                        return [4 /*yield*/, this.client.send(new CreateTableCommand(params))];
                    case 1:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    DynamoDb.prototype.getDbItem = function (primaryKey) {
        return __awaiter(this, void 0, void 0, function () {
            var params, data;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        params = {
                            ConsistentRead: true,
                            Key: (_a = {},
                                _a[this.config.table.primaryKeyColumn] = { S: primaryKey },
                                _a),
                            TableName: this.config.table.name,
                        };
                        return [4 /*yield*/, this.client.send(new GetItemCommand(params))];
                    case 1:
                        data = _b.sent();
                        return [2 /*return*/, data.Item];
                }
            });
        });
    };
    DynamoDb.prototype.loadData = function (userId, jovo) {
        return __awaiter(this, void 0, void 0, function () {
            var dbItem;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.checkRequirements();
                        return [4 /*yield*/, this.getDbItem(userId)];
                    case 1:
                        dbItem = _a.sent();
                        if (dbItem) {
                            jovo.$user.isNew = false;
                            jovo.setPersistableData(unmarshall(dbItem), this.config.storedElements);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    DynamoDb.prototype.saveData = function (userId, jovo) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var params, item;
            var _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        this.checkRequirements();
                        params = {
                            Item: (_b = {},
                                _b[this.config.table.primaryKeyColumn] = userId,
                                _b),
                            TableName: this.config.table.name,
                        };
                        item = (_c = {},
                            _c[this.config.table.primaryKeyColumn] = userId,
                            _c);
                        return [4 /*yield*/, this.applyPersistableData(jovo, item)];
                    case 1:
                        _d.sent();
                        return [4 /*yield*/, this.client.send(new PutItemCommand({
                                TableName: params.TableName,
                                Item: marshall(item, (_a = this.config.libraryConfig) === null || _a === void 0 ? void 0 : _a.marshall),
                            }))];
                    case 2:
                        _d.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    DynamoDb.prototype.checkRequirements = function () {
        if (!this.config.table.primaryKeyColumn) {
            throw new Error('this.config.table.primaryKeyColumn must not be undefined');
        }
        if (!this.config.table.name) {
            throw new Error('this.config.table.name must not be undefined');
        }
    };
    return DynamoDb;
}(DbPlugin));
export { DynamoDb };
//# sourceMappingURL=DynamoDb.js.map